#ifndef EXTENDING_H
#define EXTENDING_H

#include <chomik.h>

    class my_class
    {
    public:
        my_class(const std::string & n) {}
        // youu can add some code here!
    };

    class machine: public chomik::machine
    {
    private:
        std::vector<std::unique_ptr<my_class>> vector_of_my_class;

    public:
        machine() = default;
        virtual ~machine() = default;

        void add_my_class(std::unique_ptr<my_class> && i)
        {
            vector_of_my_class.push_back(std::move(i));
        }

        virtual void create_predefined_variables() override;

        virtual bool get_is_user_defined_executable(const chomik::signature & s) const override;

        virtual void execute_user_defined_executable(const chomik::signature & s) override;

        int get_last_created_my_class_index() const { return vector_of_my_class.size()-1; }
    };


#endif
